/*
/* $Source: /nfs/masala/projects/splot/src/RCS/plotio.c,v $
/* $Author: tuna $
/* $Header: /nfs/masala/projects/splot/src/RCS/plotio.c,v 1.1 90/07/02 14:19:44 tuna Exp $
/* $Locker:  $
/*/

/*
 * Copyright 1988 Anant Agarwal
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation.  No representations about the suitability of this software
 * for any purpose.  It is provided "as is" without express or implied 
 * warranty.
 *
 * Author:  Anant Agarwal, MIT Laboratory for Computer Science
 */

#include <stdio.h>
#include "defs.h"
#include "structs.h"
#include "plot.h"

#define BUFFERSIZE	65536
									
static char *inBuffer    = NULL;
static char *inBufferend = NULL;
static char *inBufferptr = NULL;
 
public char *GetSp(size)
     int size;
{
  char *SpPtr;
  
  if (size > BUFFERSIZE)
  {
    fprintf(stderr,"GetSp error: asking for too much at once\n");
    exit(1);
  }
  if ((inBufferptr + size) < inBufferend)
  {
    SpPtr = inBufferptr;
    inBufferptr += size;
  }								
  else
  {								
    inBuffer = malloc(BUFFERSIZE);
    if (inBuffer == NULL)
    {	
      fprintf(stderr,"GetSp error: ran out of memory \n");
      exit(1);		
    }
    else
    {
      inBufferptr = inBuffer;				
      inBufferend = inBuffer + BUFFERSIZE;
      SpPtr = inBufferptr;
      inBufferptr += size;
    }
  }
  return(SpPtr);
}


GetNewObjcurobj() 						
{	
  static int CURMAXOBJECTS=MAXOBJECTS;

  /* counts current number of objects in obj array */
  /* Each expand, doubles the size of obj array and copies contents */
  curobj++;							
  if (curobj >= CURMAXOBJECTS) 
  {
    /* create a larger array */
    expandobj(CURMAXOBJECTS);
    CURMAXOBJECTS *= 2;
  }
  obj[curobj] = (LocalObjectType *) GetSp(sizeof(LocalObjectType)); 
}

expandobj(oldnumobjs)
     int oldnumobjs;
{
  LocalObjectType **tmpobj, **freeobj;
  int i;
  
  tmpobj = (LocalObjectType **) 
    malloc(oldnumobjs * 2 * sizeof(LocalObjectType *));
  
  if (tmpobj == NULL)
  {	
    fprintf(stderr,"expandobj error: ran out of memory\n");
    exit(1);		
  }

  /* copy all old object pointers */
  for (i=0;i<oldnumobjs;i++) tmpobj[i] = obj[i];
  freeobj = obj;
  obj = tmpobj;
  free(freeobj);
}

initobj()
{
  obj = (LocalObjectType **) 
    malloc(MAXOBJECTS * sizeof(LocalObjectType *));
}
