/*
/* $Source: /am/hing/projects/splot/src/RCS/plotx11.h,v $
/* $Author: tuna $
/* $Header: /am/hing/projects/splot/src/RCS/plotx11.h,v 1.2 1992/11/03 15:36:59 tuna Exp $
/* $Locker:  $
/*/

/*
 * Copyright 1988 Anant Agarwal
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation.  No representations about the suitability of this software
 * for any purpose.  It is provided "as is" without express or implied 
 * warranty.
 *
 * Author:  Anant Agarwal, MIT Laboratory for Computer Science
 */

#include <X11/Xlib.h>
#include <X11/X10.h>
#include <X11/X.h>


/* to invert only in X */
#define MAXY 700
#define MAXX 130
/* to translate only in InterViews */
#define TY 0
#define TX 0

/* first element gives no of chars */
/* static int  SolidPattern   = 0xff; */         /* ???? */
static char  DashedPattern[]  = {2,4,4};         /* 0xf0 */
static char  StipplePattern[] = {4,4,4,2,2};     /* 0xf3 */
static char  PatPattern[]     = {4,4,4,2,2};     /* 0xf3 */
static char  DotPattern[]     = {6,6,3,1,3,1,3};

/*symbol defs */
static SymbolType currSymbol        = square;
static int        currSymbolSize    = 0;
static XPoint    *Vsym, VsymTmp[50];

/* first element is number of segments plus start point */
/* second pair is the offset from the center */

static XPoint Vcross[] = {
  5, 0,
  1, 1,				/* do not draw, rel */
  -2, -2, 
  1, 1,
  -1, 1,
  2, -2
  };

static XPoint Vtriangle[] = {
  4, 0, 
  0, -1, 
  -1, 2, 
  2, 0, 
  -1, -2 
  };

static XPoint Vdiamond[] = {
  5, 0, 
  1, 0, 
  -1, -1, 
  -1, 1, 
  1, 1, 
  1, -1 
  };

static XPoint Vsquare[] = {
  5, 0, 
  1, 1, 
  -2, 0, 
  0, -2, 
  2, 0, 
  0, 2 
  };

static XPoint Vrectangle[] = {
  5, 0, 
  1, 2, 
  -2, 0, 
  0, -4, 
  2, 0, 
  0, 4 
  };

static XPoint Vcircle[] = {
  7, 0, 
  2, 0, 
  -1, -2, 
  -2, 0, 
  -1, 2, 
  1, 2, 
  2, 0, 
  1, -2 
  };

static XPoint Vstar[] = {
  11, 0, 
  1, 1, 
  -2, -2, 
  1, 1,
  -1, 1,
  2, -2,
  -1, 1,
  0, 1,
  0, -2,
  0, 1,
  1, 0,
  -2, 0
  };

static XPoint Vplus[] = {
  5, 0, 
  0, -1, 
  0, 2, 
  0, -1,
  -1, 0,
  2, 0
  };

/* following table maps user-specified fonts to what exists */
static char DefFont[] = "fixed";

static char Pxh3[]  =  "*-helvetica-medium-r-normal--8-*";
static char Pxh4[]  =  "*-helvetica-medium-r-normal--8-*";
static char Pxh5[]  =  "*-helvetica-medium-r-normal--8-*";
static char Pxh6[]  =  "*-helvetica-medium-r-normal--8-*";
static char Pxh7[]  =  "*-helvetica-medium-r-normal--8-*";
static char Pxh8[]  =  "*-helvetica-medium-r-normal--8-*";
static char Pxh9[]  =  "*-helvetica-medium-r-normal--10-*";
static char Pxh10[] =  "*-helvetica-medium-r-normal--10-*";
static char Pxh11[] =  "*-helvetica-medium-r-normal--11-*";
static char Pxh12[] =  "*-helvetica-medium-r-normal--12-*";
static char Pxh13[] =  "*-helvetica-medium-r-normal--14-*";
static char Pxh14[] =  "*-helvetica-medium-r-normal--14-*";
static char Pxh15[] =  "*-helvetica-medium-r-normal--14-*";
static char Pxh16[] =  "*-helvetica-medium-r-normal--17-*";
static char Pxh17[] =  "*-helvetica-medium-r-normal--17-*";
static char Pxh18[] =  "*-helvetica-medium-r-normal--18-*";
static char Pxh19[] =  "*-helvetica-medium-r-normal--20-*";
static char Pxh20[] =  "*-helvetica-medium-r-normal--20-*";
static char Pxh21[] =  "*-helvetica-medium-r-normal--20-*";
static char Pxh22[] =  "*-helvetica-medium-r-normal--24-*";
static char Pxh23[] =  "*-helvetica-medium-r-normal--24-*";
static char Pxh24[] =  "*-helvetica-medium-r-normal--24-*";
static char Pxh25[] =  "*-helvetica-medium-r-normal--25-*";
static char Pxh26[] =  "*-helvetica-medium-r-normal--25-*";
static char Pxh27[] =  "*-helvetica-medium-r-normal--25-*";
static char Pxh28[] =  "*-helvetica-medium-r-normal--25-*";
static char Pxh29[] =  "*-helvetica-medium-r-normal--25-*";
static char Pxh30[] =  "*-helvetica-medium-r-normal--25-*";

static char Pxhb3[]  =  "*-helvetica-bold-r-normal--8-*";
static char Pxhb4[]  =  "*-helvetica-bold-r-normal--8-*";
static char Pxhb5[]  =  "*-helvetica-bold-r-normal--8-*";
static char Pxhb6[]  =  "*-helvetica-bold-r-normal--8-*";
static char Pxhb7[]  =  "*-helvetica-bold-r-normal--8-*";
static char Pxhb8[]  =  "*-helvetica-bold-r-normal--8-*";
static char Pxhb9[]  =  "*-helvetica-bold-r-normal--10-*";
static char Pxhb10[] =  "*-helvetica-bold-r-normal--10-*";
static char Pxhb11[] =  "*-helvetica-bold-r-normal--11-*";
static char Pxhb12[] =  "*-helvetica-bold-r-normal--12-*";
static char Pxhb13[] =  "*-helvetica-bold-r-normal--14-*";
static char Pxhb14[] =  "*-helvetica-bold-r-normal--14-*";
static char Pxhb15[] =  "*-helvetica-bold-r-normal--14-*";
static char Pxhb16[] =  "*-helvetica-bold-r-normal--17-*";
static char Pxhb17[] =  "*-helvetica-bold-r-normal--17-*";
static char Pxhb18[] =  "*-helvetica-bold-r-normal--18-*";
static char Pxhb19[] =  "*-helvetica-bold-r-normal--20-*";
static char Pxhb20[] =  "*-helvetica-bold-r-normal--20-*";
static char Pxhb21[] =  "*-helvetica-bold-r-normal--20-*";
static char Pxhb22[] =  "*-helvetica-bold-r-normal--24-*";
static char Pxhb23[] =  "*-helvetica-bold-r-normal--24-*";
static char Pxhb24[] =  "*-helvetica-bold-r-normal--24-*";
static char Pxhb25[] =  "*-helvetica-bold-r-normal--25-*";
static char Pxhb26[] =  "*-helvetica-bold-r-normal--25-*";
static char Pxhb27[] =  "*-helvetica-bold-r-normal--25-*";
static char Pxhb28[] =  "*-helvetica-bold-r-normal--25-*";
static char Pxhb29[] =  "*-helvetica-bold-r-normal--25-*";
static char Pxhb30[] =  "*-helvetica-bold-r-normal--25-*";

static char Pxhi3[]  =  "*-helvetica-medium-o-normal--8-*";
static char Pxhi4[]  =  "*-helvetica-medium-o-normal--8-*";
static char Pxhi5[]  =  "*-helvetica-medium-o-normal--8-*";
static char Pxhi6[]  =  "*-helvetica-medium-o-normal--8-*";
static char Pxhi7[]  =  "*-helvetica-medium-o-normal--8-*";
static char Pxhi8[]  =  "*-helvetica-medium-o-normal--8-*";
static char Pxhi9[]  =  "*-helvetica-medium-o-normal--10-*";
static char Pxhi10[] =  "*-helvetica-medium-o-normal--10-*";
static char Pxhi11[] =  "*-helvetica-medium-o-normal--11-*";
static char Pxhi12[] =  "*-helvetica-medium-o-normal--12-*";
static char Pxhi13[] =  "*-helvetica-medium-o-normal--14-*";
static char Pxhi14[] =  "*-helvetica-medium-o-normal--14-*";
static char Pxhi15[] =  "*-helvetica-medium-o-normal--14-*";
static char Pxhi16[] =  "*-helvetica-medium-o-normal--17-*";
static char Pxhi17[] =  "*-helvetica-medium-o-normal--17-*";
static char Pxhi18[] =  "*-helvetica-medium-o-normal--18-*";
static char Pxhi19[] =  "*-helvetica-medium-o-normal--20-*";
static char Pxhi20[] =  "*-helvetica-medium-o-normal--20-*";
static char Pxhi21[] =  "*-helvetica-medium-o-normal--20-*";
static char Pxhi22[] =  "*-helvetica-medium-o-normal--24-*";
static char Pxhi23[] =  "*-helvetica-medium-o-normal--24-*";
static char Pxhi24[] =  "*-helvetica-medium-o-normal--24-*";
static char Pxhi25[] =  "*-helvetica-medium-o-normal--25-*";
static char Pxhi26[] =  "*-helvetica-medium-o-normal--25-*";
static char Pxhi27[] =  "*-helvetica-medium-o-normal--25-*";
static char Pxhi28[] =  "*-helvetica-medium-o-normal--25-*";
static char Pxhi29[] =  "*-helvetica-medium-o-normal--25-*";
static char Pxhi30[] =  "*-helvetica-medium-o-normal--25-*";

static char Pxhbi3[]  =  "*-helvetica-bold-o-normal--8-*";
static char Pxhbi4[]  =  "*-helvetica-bold-o-normal--8-*";
static char Pxhbi5[]  =  "*-helvetica-bold-o-normal--8-*";
static char Pxhbi6[]  =  "*-helvetica-bold-o-normal--8-*";
static char Pxhbi7[]  =  "*-helvetica-bold-o-normal--8-*";
static char Pxhbi8[]  =  "*-helvetica-bold-o-normal--8-*";
static char Pxhbi9[]  =  "*-helvetica-bold-o-normal--10-*";
static char Pxhbi10[] =  "*-helvetica-bold-o-normal--10-*";
static char Pxhbi11[] =  "*-helvetica-bold-o-normal--11-*";
static char Pxhbi12[] =  "*-helvetica-bold-o-normal--12-*";
static char Pxhbi13[] =  "*-helvetica-bold-o-normal--14-*";
static char Pxhbi14[] =  "*-helvetica-bold-o-normal--14-*";
static char Pxhbi15[] =  "*-helvetica-bold-o-normal--14-*";
static char Pxhbi16[] =  "*-helvetica-bold-o-normal--17-*";
static char Pxhbi17[] =  "*-helvetica-bold-o-normal--17-*";
static char Pxhbi18[] =  "*-helvetica-bold-o-normal--18-*";
static char Pxhbi19[] =  "*-helvetica-bold-o-normal--20-*";
static char Pxhbi20[] =  "*-helvetica-bold-o-normal--20-*";
static char Pxhbi21[] =  "*-helvetica-bold-o-normal--20-*";
static char Pxhbi22[] =  "*-helvetica-bold-o-normal--24-*";
static char Pxhbi23[] =  "*-helvetica-bold-o-normal--24-*";
static char Pxhbi24[] =  "*-helvetica-bold-o-normal--24-*";
static char Pxhbi25[] =  "*-helvetica-bold-o-normal--25-*";
static char Pxhbi26[] =  "*-helvetica-bold-o-normal--25-*";
static char Pxhbi27[] =  "*-helvetica-bold-o-normal--25-*";
static char Pxhbi28[] =  "*-helvetica-bold-o-normal--25-*";
static char Pxhbi29[] =  "*-helvetica-bold-o-normal--25-*";
static char Pxhbi30[] =  "*-helvetica-bold-o-normal--25-*";

static char Pxt3[]  =  "*-times-medium-r-normal--8-*";
static char Pxt4[]  =  "*-times-medium-r-normal--8-*";
static char Pxt5[]  =  "*-times-medium-r-normal--8-*";
static char Pxt6[]  =  "*-times-medium-r-normal--8-*";
static char Pxt7[]  =  "*-times-medium-r-normal--8-*";
static char Pxt8[]  =  "*-times-medium-r-normal--8-*";
static char Pxt9[]  =  "*-times-medium-r-normal--10-*";
static char Pxt10[] =  "*-times-medium-r-normal--10-*";
static char Pxt11[] =  "*-times-medium-r-normal--11-*";
static char Pxt12[] =  "*-times-medium-r-normal--12-*";
static char Pxt13[] =  "*-times-medium-r-normal--14-*";
static char Pxt14[] =  "*-times-medium-r-normal--14-*";
static char Pxt15[] =  "*-times-medium-r-normal--14-*";
static char Pxt16[] =  "*-times-medium-r-normal--17-*";
static char Pxt17[] =  "*-times-medium-r-normal--17-*";
static char Pxt18[] =  "*-times-medium-r-normal--18-*";
static char Pxt19[] =  "*-times-medium-r-normal--20-*";
static char Pxt20[] =  "*-times-medium-r-normal--20-*";
static char Pxt21[] =  "*-times-medium-r-normal--20-*";
static char Pxt22[] =  "*-times-medium-r-normal--24-*";
static char Pxt23[] =  "*-times-medium-r-normal--24-*";
static char Pxt24[] =  "*-times-medium-r-normal--24-*";
static char Pxt25[] =  "*-times-medium-r-normal--25-*";
static char Pxt26[] =  "*-times-medium-r-normal--25-*";
static char Pxt27[] =  "*-times-medium-r-normal--25-*";
static char Pxt28[] =  "*-times-medium-r-normal--25-*";
static char Pxt29[] =  "*-times-medium-r-normal--25-*";
static char Pxt30[] =  "*-times-medium-r-normal--25-*";

static char Pxtb3[]  =  "*-times-bold-r-normal--8-*";
static char Pxtb4[]  =  "*-times-bold-r-normal--8-*";
static char Pxtb5[]  =  "*-times-bold-r-normal--8-*";
static char Pxtb6[]  =  "*-times-bold-r-normal--8-*";
static char Pxtb7[]  =  "*-times-bold-r-normal--8-*";
static char Pxtb8[]  =  "*-times-bold-r-normal--8-*";
static char Pxtb9[]  =  "*-times-bold-r-normal--10-*";
static char Pxtb10[] =  "*-times-bold-r-normal--10-*";
static char Pxtb11[] =  "*-times-bold-r-normal--11-*";
static char Pxtb12[] =  "*-times-bold-r-normal--12-*";
static char Pxtb13[] =  "*-times-bold-r-normal--14-*";
static char Pxtb14[] =  "*-times-bold-r-normal--14-*";
static char Pxtb15[] =  "*-times-bold-r-normal--14-*";
static char Pxtb16[] =  "*-times-bold-r-normal--17-*";
static char Pxtb17[] =  "*-times-bold-r-normal--17-*";
static char Pxtb18[] =  "*-times-bold-r-normal--18-*";
static char Pxtb19[] =  "*-times-bold-r-normal--20-*";
static char Pxtb20[] =  "*-times-bold-r-normal--20-*";
static char Pxtb21[] =  "*-times-bold-r-normal--20-*";
static char Pxtb22[] =  "*-times-bold-r-normal--24-*";
static char Pxtb23[] =  "*-times-bold-r-normal--24-*";
static char Pxtb24[] =  "*-times-bold-r-normal--24-*";
static char Pxtb25[] =  "*-times-bold-r-normal--25-*";
static char Pxtb26[] =  "*-times-bold-r-normal--25-*";
static char Pxtb27[] =  "*-times-bold-r-normal--25-*";
static char Pxtb28[] =  "*-times-bold-r-normal--25-*";
static char Pxtb29[] =  "*-times-bold-r-normal--25-*";
static char Pxtb30[] =  "*-times-bold-r-normal--25-*";

static char Pxti3[]  =  "*-times-medium-i-normal--8-*";
static char Pxti4[]  =  "*-times-medium-i-normal--8-*";
static char Pxti5[]  =  "*-times-medium-i-normal--8-*";
static char Pxti6[]  =  "*-times-medium-i-normal--8-*";
static char Pxti7[]  =  "*-times-medium-i-normal--8-*";
static char Pxti8[]  =  "*-times-medium-i-normal--8-*";
static char Pxti9[]  =  "*-times-medium-i-normal--10-*";
static char Pxti10[] =  "*-times-medium-i-normal--10-*";
static char Pxti11[] =  "*-times-medium-i-normal--11-*";
static char Pxti12[] =  "*-times-medium-i-normal--12-*";
static char Pxti13[] =  "*-times-medium-i-normal--14-*";
static char Pxti14[] =  "*-times-medium-i-normal--14-*";
static char Pxti15[] =  "*-times-medium-i-normal--14-*";
static char Pxti16[] =  "*-times-medium-i-normal--17-*";
static char Pxti17[] =  "*-times-medium-i-normal--17-*";
static char Pxti18[] =  "*-times-medium-i-normal--18-*";
static char Pxti19[] =  "*-times-medium-i-normal--20-*";
static char Pxti20[] =  "*-times-medium-i-normal--20-*";
static char Pxti21[] =  "*-times-medium-i-normal--20-*";
static char Pxti22[] =  "*-times-medium-i-normal--24-*";
static char Pxti23[] =  "*-times-medium-i-normal--24-*";
static char Pxti24[] =  "*-times-medium-i-normal--24-*";
static char Pxti25[] =  "*-times-medium-i-normal--25-*";
static char Pxti26[] =  "*-times-medium-i-normal--25-*";
static char Pxti27[] =  "*-times-medium-i-normal--25-*";
static char Pxti28[] =  "*-times-medium-i-normal--25-*";
static char Pxti29[] =  "*-times-medium-i-normal--25-*";
static char Pxti30[] =  "*-times-medium-i-normal--25-*";

static char Pxtbi3[]  =  "*-times-bold-i-normal--8-*";
static char Pxtbi4[]  =  "*-times-bold-i-normal--8-*";
static char Pxtbi5[]  =  "*-times-bold-i-normal--8-*";
static char Pxtbi6[]  =  "*-times-bold-i-normal--8-*";
static char Pxtbi7[]  =  "*-times-bold-i-normal--8-*";
static char Pxtbi8[]  =  "*-times-bold-i-normal--8-*";
static char Pxtbi9[]  =  "*-times-bold-i-normal--10-*";
static char Pxtbi10[] =  "*-times-bold-i-normal--10-*";
static char Pxtbi11[] =  "*-times-bold-i-normal--11-*";
static char Pxtbi12[] =  "*-times-bold-i-normal--12-*";
static char Pxtbi13[] =  "*-times-bold-i-normal--14-*";
static char Pxtbi14[] =  "*-times-bold-i-normal--14-*";
static char Pxtbi15[] =  "*-times-bold-i-normal--14-*";
static char Pxtbi16[] =  "*-times-bold-i-normal--17-*";
static char Pxtbi17[] =  "*-times-bold-i-normal--17-*";
static char Pxtbi18[] =  "*-times-bold-i-normal--18-*";
static char Pxtbi19[] =  "*-times-bold-i-normal--20-*";
static char Pxtbi20[] =  "*-times-bold-i-normal--20-*";
static char Pxtbi21[] =  "*-times-bold-i-normal--20-*";
static char Pxtbi22[] =  "*-times-bold-i-normal--24-*";
static char Pxtbi23[] =  "*-times-bold-i-normal--24-*";
static char Pxtbi24[] =  "*-times-bold-i-normal--24-*";
static char Pxtbi25[] =  "*-times-bold-i-normal--25-*";
static char Pxtbi26[] =  "*-times-bold-i-normal--25-*";
static char Pxtbi27[] =  "*-times-bold-i-normal--25-*";
static char Pxtbi28[] =  "*-times-bold-i-normal--25-*";
static char Pxtbi29[] =  "*-times-bold-i-normal--25-*";
static char Pxtbi30[] =  "*-times-bold-i-normal--25-*";

static char Pgrk3[]  =  "*-symbol-medium-r-normal--8-*";
static char Pgrk4[]  =  "*-symbol-medium-r-normal--8-*";
static char Pgrk5[]  =  "*-symbol-medium-r-normal--8-*";
static char Pgrk6[]  =  "*-symbol-medium-r-normal--8-*";
static char Pgrk7[]  =  "*-symbol-medium-r-normal--8-*";
static char Pgrk8[]  =  "*-symbol-medium-r-normal--8-*";
static char Pgrk9[]  =  "*-symbol-medium-r-normal--10-*";
static char Pgrk10[] =  "*-symbol-medium-r-normal--10-*";
static char Pgrk11[] =  "*-symbol-medium-r-normal--11-*";
static char Pgrk12[] =  "*-symbol-medium-r-normal--12-*";
static char Pgrk13[] =  "*-symbol-medium-r-normal--14-*";
static char Pgrk14[] =  "*-symbol-medium-r-normal--14-*";
static char Pgrk15[] =  "*-symbol-medium-r-normal--14-*";
static char Pgrk16[] =  "*-symbol-medium-r-normal--17-*";
static char Pgrk17[] =  "*-symbol-medium-r-normal--17-*";
static char Pgrk18[] =  "*-symbol-medium-r-normal--18-*";
static char Pgrk19[] =  "*-symbol-medium-r-normal--20-*";
static char Pgrk20[] =  "*-symbol-medium-r-normal--20-*";
static char Pgrk21[] =  "*-symbol-medium-r-normal--20-*";
static char Pgrk22[] =  "*-symbol-medium-r-normal--24-*";
static char Pgrk23[] =  "*-symbol-medium-r-normal--24-*";
static char Pgrk24[] =  "*-symbol-medium-r-normal--24-*";
static char Pgrk25[] =  "*-symbol-medium-r-normal--25-*";
static char Pgrk26[] =  "*-symbol-medium-r-normal--25-*";
static char Pgrk27[] =  "*-symbol-medium-r-normal--25-*";
static char Pgrk28[] =  "*-symbol-medium-r-normal--25-*";
static char Pgrk29[] =  "*-symbol-medium-r-normal--25-*";
static char Pgrk30[] =  "*-symbol-medium-r-normal--25-*";

#define NUMFNTSIZS (MAXFNTSIZ-MINFNTSIZ+1)

char *xhfont[NUMFNTSIZS] = {
Pxh3,Pxh4,Pxh5,Pxh6,Pxh7,Pxh8,Pxh9,Pxh10,Pxh11,Pxh12,Pxh13,Pxh14,
Pxh15,Pxh16,Pxh17,Pxh18,Pxh19,Pxh20,Pxh21,Pxh22,Pxh23,Pxh24,Pxh25,
Pxh26,Pxh27,Pxh28,Pxh29,Pxh30
};

char *xhbfont[NUMFNTSIZS] = {
Pxhb3,Pxhb4,Pxhb5,Pxhb6,Pxhb7,Pxhb8,Pxhb9,Pxhb10,Pxhb11,Pxhb12,
Pxhb13,Pxhb14,Pxhb15,Pxhb16,Pxhb17,Pxhb18,Pxhb19,Pxhb20,Pxhb21,
Pxhb22,Pxhb23,Pxhb24,Pxhb25,Pxhb26,Pxhb27,Pxhb28,Pxhb29,Pxhb30
};

char *xhifont[NUMFNTSIZS] = {
Pxhi3,Pxhi4,Pxhi5,Pxhi6,Pxhi7,Pxhi8,Pxhi9,Pxhi10,Pxhi11,Pxhi12,Pxhi13,Pxhi14,
Pxhi15,Pxhi16,Pxhi17,Pxhi18,Pxhi19,Pxhi20,Pxhi21,Pxhi22,Pxhi23,Pxhi24,Pxhi25,
Pxhi26,Pxhi27,Pxhi28,Pxhi29,Pxhi30
};

char *xhbifont[NUMFNTSIZS] = {
Pxhbi3,Pxhbi4,Pxhbi5,Pxhbi6,Pxhbi7,Pxhbi8,Pxhbi9,Pxhbi10,Pxhbi11,Pxhbi12,
Pxhbi13,Pxhbi14,Pxhbi15,Pxhbi16,Pxhbi17,Pxhbi18,Pxhbi19,Pxhbi20,Pxhbi21,
Pxhbi22,Pxhbi23,Pxhbi24,Pxhbi25,Pxhbi26,Pxhbi27,Pxhbi28,Pxhbi29,Pxhbi30
};

char *xtfont[NUMFNTSIZS] = {
Pxt3,Pxt4,Pxt5,Pxt6,Pxt7,Pxt8,Pxt9,Pxt10,Pxt11,Pxt12,Pxt13,Pxt14,
Pxt15,Pxt16,Pxt17,Pxt18,Pxt19,Pxt20,Pxt21,Pxt22,Pxt23,Pxt24,Pxt25,
Pxt26,Pxt27,Pxt28,Pxt29,Pxt30
};

char *xtbfont[NUMFNTSIZS] = {
Pxtb3,Pxtb4,Pxtb5,Pxtb6,Pxtb7,Pxtb8,Pxtb9,Pxtb10,Pxtb11,Pxtb12,
Pxtb13,Pxtb14,Pxtb15,Pxtb16,Pxtb17,Pxtb18,Pxtb19,Pxtb20,Pxtb21,
Pxtb22,Pxtb23,Pxtb24,Pxtb25,Pxtb26,Pxtb27,Pxtb28,Pxtb29,Pxtb30
};

char *xtifont[NUMFNTSIZS] = {
Pxti3,Pxti4,Pxti5,Pxti6,Pxti7,Pxti8,Pxti9,Pxti10,Pxti11,Pxti12,Pxti13,Pxti14,
Pxti15,Pxti16,Pxti17,Pxti18,Pxti19,Pxti20,Pxti21,Pxti22,Pxti23,Pxti24,Pxti25,
Pxti26,Pxti27,Pxti28,Pxti29,Pxti30
};

char *xtbifont[NUMFNTSIZS] = {
Pxtbi3,Pxtbi4,Pxtbi5,Pxtbi6,Pxtbi7,Pxtbi8,Pxtbi9,Pxtbi10,Pxtbi11,Pxtbi12,
Pxtbi13,Pxtbi14,Pxtbi15,Pxtbi16,Pxtbi17,Pxtbi18,Pxtbi19,Pxtbi20,Pxtbi21,
Pxtbi22,Pxtbi23,Pxtbi24,Pxtbi25,Pxtbi26,Pxtbi27,Pxtbi28,Pxtbi29,Pxtbi30
};

char *GreekMap[NUMFNTSIZS] = {
Pgrk3,Pgrk4,Pgrk5,Pgrk6,Pgrk7,Pgrk8,Pgrk9,Pgrk10,Pgrk11,Pgrk12,
Pgrk13,Pgrk14,Pgrk15,Pgrk16,Pgrk17,Pgrk18,Pgrk19,Pgrk20,Pgrk21,
Pgrk22,Pgrk23,Pgrk24,Pgrk25,Pgrk26,Pgrk27,Pgrk28,Pgrk29,Pgrk30
};

XFontStruct *deffont_cache;
XFontStruct *xhfont_cache[NUMFNTSIZS];
XFontStruct *xhbfont_cache[NUMFNTSIZS];
XFontStruct *xhifont_cache[NUMFNTSIZS];
XFontStruct *xhbifont_cache[NUMFNTSIZS];
XFontStruct *xtfont_cache[NUMFNTSIZS];
XFontStruct *xtbfont_cache[NUMFNTSIZS];
XFontStruct *xtifont_cache[NUMFNTSIZS];
XFontStruct *xtbifont_cache[NUMFNTSIZS];
XFontStruct *GreekMap_cache[NUMFNTSIZS];

static char dashmark[] = "-";
